/* tslint:disable */
/* eslint-disable */
/**
* Convert a DFA JSON to a mermaid graph
* @param {string} dfa_json
* @returns {string}
*/
export function dfa2mermaid(dfa_json: string): string;
/**
* Convert a NFA JSON to a mermaid graph
* @param {string} nfa_json
* @returns {string}
*/
export function nfa2mermaid(nfa_json: string): string;
/**
* Construct a NFA from a regular expression
* and return the JSON representation
* We only support the following syntax:
* ```txt
* <regex> ::= <term> '|' <regex> | <term>
* <term> ::= <factor> <term> | <factor>
* <factor> ::= <base> '*' | <base>
* <base> ::= <char> | '(' <regex> ')'
* ```
* @param {string} reg
* @returns {string}
*/
export function reg2nfa(reg: string): string;
/**
* Convert a NFA JSON to a DFA JSON
* @param {string} nfa_json
* @returns {string}
*/
export function nfa2dfa(nfa_json: string): string;
/**
* Convert a NFA to a DFA
* and return a markdown representation of the process
* @param {string} nfa_json
* @returns {string}
*/
export function nfa2dfa_markdown(nfa_json: string): string;
/**
* Minimize a DFA
* @param {string} dfa_json
* @returns {string}
*/
export function minimize_dfa(dfa_json: string): string;
/**
* Minimize a DFA
* and return a markdown representation of the process
* @param {string} dfa_json
* @returns {string}
*/
export function minimize_dfa_markdown(dfa_json: string): string;
